//*****************************************************************************
//
// File Name	: 'main.c'
// Title		: SPI interface driver for the LSU7S1011A SED1530 graphic LCD
// Author		: based on code for E0855-2 by Marc Meise, adapted for LSU7S1011A by Peter Lampe
// Adapted		; Septempber 2010
// Version		: Beta
// Target MCU	: Atmel AVR series
//
//
// This code is distributed under the GNU Public License
// which can be found at http://www.gnu.org/licenses/gpl.txt
//
//*****************************************************************************

/*  
	Disclaimer:
	This code is highly beta and might lack some funcionality and/or documentation.
	Furthermore the code has not been properly tested.
	Nevertheless, please expect most functions to work.
	

	I will not take any responsibility or what so ever for the functionality of the LSU7S1011A SED1530 driver.
	If you wreck anything - it's your own business...
	Modify this code and contribute freely.

  special thank to Marc Meise for his fundamental works to this project
  Just a small Test-Program to demonstrate the functions of the LSU7S1011A SED1530 driver.
*/






/*  
	The GLCD is connected via SPI.
		Please feel free to modify the driver to your own purpose.

	Disclaimer:I will not take any responsibility or what so ever for the functionality of the E0855-2 SED1530 driver.
	If you wreck anything - it's your own business...
	Modify this code and contribute freely.
*/

// PC0 is congured as a switch to step through the demo.

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <inttypes.h>
#include <SED1530.h>
#include <font.h>
#include <PICS.h>
#include <stdlib.h>
#include <avr/interrupt.h>


void pressbutton (void);

/* define CPU frequency in Mhz here if not defined in Makefile */
#ifndef F_CPU
#define F_CPU 8000000UL
#endif


unsigned char count=0;

char A[5][16] PROGMEM=
 	{"Konstante, ", 
	 "aus dem",
	 "PROGMEM",
	 "gelesen"
 	};


int main (void)
{
 unsigned char x;
 
															//(P.L.)
DDRB=0b00101111;							//alle verwendeten Steuerleitungen auf Ausgang setzen
PORTB=0b00101111;							//alle verwendeten Steuerleitungen auf 1 setzen


												//(P.L.)
 DDRC&=~(1<<PIN0);			//PC0 als Eingang fr Taster
 PORTC|=1<<PIN0	;				//und dazu den Pullup-Widerstand setzen
 
 Init_SED1530();				
 SED_contrast (17);			
 SED_clear();						

while (1)
{
 
 SED_clear();
 SED_set_XY(3,10);
 SED_puts("This is a DEMO");
 SED_set_XY(2,15); 
 SED_puts("of the GLCD");
 SED_set_XY(1,17);
 SED_puts("LSU7S1011A");	//(P.L.)
 SED_set_XY(0,27);
 SED_puts("hard-SPI");	//(P.L.)


 pressbutton();
 SED_clear_page(0);
 SED_set_XY(0,1);
 SED_puts("A Number: ");
 SED_puts_num(32129);

 pressbutton();						//(P.L.)
 SED_clear();
 SED_set_XY(3,0);
 SED_puts("  Die Umlaute:");
 SED_set_XY(1,7);
 SED_puts("------");
 
 pressbutton();						//(P.L.)
 SED_clear();
 SED_set_XY(3,0);
 SED_puts(" Sonderzeichen:");
 SED_set_XY(1,3);
 for (x=0; x<=7; x++)
  {
	SED_uchar(x);
	SED_putc (' ');
	}
 
 pressbutton();
 SED_clear();
 SED_set_XY(3,0);
 SED_puts_p(A[0]); // Read out of Progmem
 SED_set_XY(2,0);
 SED_puts_p(A[1]);
 SED_set_XY(1,0);
 SED_puts_p(A[2]);
 SED_set_XY(0,0);
 SED_puts_p(A[3]);

 pressbutton();
 SED_showPIC (0);

 pressbutton();
 SED_showPIC (1);
 
 pressbutton();
 SED_showPIC (2);
 
 pressbutton();
 SED_clear();

 
 for (x=0; x<=95; x++)
 	{
 	 SED_pixel(x, 0, 0b00000001);	 
	 SED_pixel(x, 3, 0b10000000);
	}
 for (x=0; x<=3; x++)
 	{
 	 SED_pixel(0, x, 0b11111111);	 
	 SED_pixel(95, x, 0b11111111);
	}

 SED_set_XY(2,8);
 SED_puts("Frame and Bar");
 SED_pixel(7, 1, 0b01111110);
 SED_pixel(86, 1,0b01111110);
 for(x=8; x<=85;x++)
 {
  SED_pixel(x, 1, 0b11111111);
 }

  for(x=9; x<=84;x++)
 {
  SED_pixel(x, 1, 0b10000001);
  delay();
 }
 SED_set_XY(2,8);
 SED_puts("Press Button  ");

 pressbutton();

 SED_pixel(7, 1, 0x00);
 SED_pixel(86, 1,0x00);

 for(x=8; x<=85;x++)
 {
  SED_pixel(x, 1, 0b11111111);
  SED_pixel(x, 2, 0b11111111);
 }

  for(x=84; x>=50;x--)
 {
  SED_pixel(x, 1, 0b00000001);
  SED_pixel(x, 2, 0b10000000);
  delay();
 }

  for(x=9; x<=49;x++)
 {
  SED_pixel(x, 1, 0b00000001);
  SED_pixel(x, 2, 0b10000000);
  delay();
 }
 delay();
 delay();

 SED_clear();

 SED_puts("Going to sleep");
 SED_newline();
 SED_puts("Press Button!");
 SED_newline();
 SED_puts("Press PC0 again");
 SED_newline();
 SED_puts("to wake-up!");
 
 PORTB&=~(1<<PB6);
 SED_sleep();

 pressbutton();
 SED_wakeup();
 PORTB|=(1<<PB6);
 SED_clear();

 SED_puts("SED1530 Woke-up!");
 SED_newline();
 SED_newline();
 SED_puts("Press PC0 again");
 SED_newline();
 SED_puts("to continue demo");

 pressbutton();

	}
 return(0);
}

//_____________ Funtionen _____________

void pressbutton (void)
{
 while (!( PINC & (1<<PC0)))
 	{
 	delay();
	}
 while ( PINC & (1<<PC0)) ; 
 delay();
}




